import 'dart:io';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:path_provider/path_provider.dart';
import 'package:speech_to_text_google/src/speech_to_text.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Speech To Text Demo',
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'Demo'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  // This widget is the home page of your application. It is stateful, meaning
  // that it has a State object (defined below) that contains fields that affect
  // how it looks.

  // This class is the configuration for the state. It holds the values (in this
  // case the title) provided by the parent (in this case the App widget) and
  // used by the build method of the State. Fields in a Widget subclass are
  // always marked "final".

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;
  String content = "";
  String change = "";

  void _doS2T() async {
    String json = r"""{
  "type": "service_account",
  "project_id": "shadow-250608",
  "private_key_id": "29568a6974a17529abb819789d0ef42226653ada",
  "private_key": "-----BEGIN PRIVATE KEY-----\nMIIEvwIBADANBgkqhkiG9w0BAQEFAASCBKkwggSlAgEAAoIBAQDUTUQxP/uidxZ8\nH9HTL5SvcTCQhTKibCjZcccbG7eTp7dMC8BrYPDWp54NJv13KjFF/pmsxyYFyXj1\n20nlsoExmWQSnF/sZJYeqct/aTBWZbFdsNznKRb7rDQ/TLPqwV/ISLECKa2kNn//\nx0UU9D6zUUq6kgy8Wqg4MIuUnlJcU7RHcmVOIPAFoIfeAO0fO+mnlRTLGRDfct77\n7rjHZJVzwUZWLJy7sswMMVxkI40oG9GdMpZubkU4wx85MZKFsy+bf+lPbMoHTnf7\nnIiwhzxWpEJfJOyyDqOaypCEbpZKmw9MG8gudZtNJJApbdZVV4Nw/yr3cn8G1c1l\nEE7SWPBvAgMBAAECggEAVnmEgcUMk8ALLhLt7iYO26lwvSUsG0GQIAX6sl2HWILz\no+uTfIl3gA+1TqknjA7pFBgg82II6EmI1if0wTWE7zWKMBR28/yCs0m5JJQthruU\nU9PTHus7O9cITxJIpKIQiC2nv/hHDMDQQVijGGZmVbcSh80ul9gbdgu8BxS3+ne1\n5dMyqLiE3otXAVHhR1cnVpNhsBHFoFD4GIP60N7JJEaAsT3RkESSw0IAaMMbnhTl\nvAyPy1bBATkMVYAopTIjzmvTN7FRsWIymGhK9mlCdgXob/Cza0l5prbxJwU1beCx\nKzJ4hKi3Z7HCh+zsffi9iqaekawRQT2iv64m8qtdrQKBgQDq3gh+2R1sxcmEETd7\nI9mnVh+VUhKTTRBnrDuuc7Xe6GqXTkqohDO207IX8fLelTV77vCIlHu/hnYk9Pp4\npAOBpO711LP4U7AYaeWC7Jule/nqPyp6ba7t6FBpkwUjChMJLdIN2FTEcHYGBvTR\nFv7CVzusSm0yPUK0PHwOyrjfCwKBgQDnZ3TWd3AzMkIrCmiSLaGYLNjaPhN5Nlp2\nzGR7ErMhD0prHe9JMplzRXcOhhgSA/JH4Zckjn4rHBKvLmD/lRpG7X4puF7wJKNC\ndmsIXfZP5mBESODXqYQF2TcMJObjRGKmuRLrRKOAl2IIhPUjxPzpLGexSf4/SVpJ\nirH7jxhirQKBgQDh2Nh6gfUVn6wD3zpmozas/tgoEl/iXXyk9K3/Ny1wSDYXgSWx\nnk7MRA1BkVtmRjzEDCQocf/9UCNTrm8cizsD88IFip/07ySqlUop97REEU9kvZDv\nYYGRLJAGtWV/KDTd4r3Wqmv46dvUN+Q7G82mu5OaPYd7hAUco/z3jGDxuQKBgQDQ\nCzJ/Myi7zp6wpY34hm/3KbLZG+BUJOrWTdK0184WlfG5NlOQwp41hamRdDulzsh/\nmbFSW43RYk7mEtOAVWQnipPYHHu2eaoSMfbusdOmaB/6pG8JVc1tmKmmEHNIto3f\nCRuaS76X+QJZWHgw7YTYemTLfxPHgEJdRgXYfgFVjQKBgQCQgYhUXbePsyBjpDU4\n8d8+mHTVPzsXzLD3qZxf1a8teYBf3Bn0vpF2WZ8c9FlX59haw/VI9MMMHJlcQR6H\n87iRHK2vcQIG0i8m22lbjSFM3kGzD9tZyhx9hIGh1J1Pfl8gOvZwZ83p/gFo4lb0\noB/0S53Nxte1ZkVNyvBFsScGUA==\n-----END PRIVATE KEY-----\n",
  "client_email": "starting-account-st6f38jpnhli@shadow-250608.iam.gserviceaccount.com",
  "client_id": "101686508573877472987",
  "auth_uri": "https://accounts.google.com/o/oauth2/auth",
  "token_uri": "https://oauth2.googleapis.com/token",
  "auth_provider_x509_cert_url": "https://www.googleapis.com/oauth2/v1/certs",
  "client_x509_cert_url": "https://www.googleapis.com/robot/v1/metadata/x509/starting-account-st6f38jpnhli%40shadow-250608.iam.gserviceaccount.com"
}
""";
    SpeechToText speechToText = SpeechToText.initWithAccount(credentials: json);
    // SpeechToText speechToText = SpeechToText(credentials: json);
    // SpeechToText speechToText =
    //     SpeechToText.initWithToken(fetchToken: fetchToken);
    var data = await rootBundle.load('assets/test.wav');
    final directory = await getApplicationDocumentsDirectory();
    String path = directory.path + '/test.wav';
    await File(path).writeAsBytes(
        data.buffer.asUint8List(data.offsetInBytes, data.lengthInBytes));
    Stream<List<int>> audioStream = File(path).openRead();
    await for (var resp
        in speechToText.convert(audioStream, sampleRate: 16000)) {
      setState(() {
        if (resp["isFinal"]) {
          content += resp["transcript"];
          change = "";
        } else {
          change = resp["transcript"];
        }
      });
      print(resp);
    }
  }

  Future<Map> fetchToken() {
    Map token = {
      "token":
          "ya29.c.Kl6wBxn6VWQXZ9R62yN00QB-C9cb5kJaf2LwOsWd1wneCIuMjGPf6xdjileUrS8Eh6StsZe8pCTnrAajnyvNEu0-1md_nQqLvq6gg89sh2tj1IGRzCkkwg6FBHmD9xZr",
      "expiry": "2019-11-06 13:52:06.369570"
    };
    return Future.value(token);
  }

  @override
  Widget build(BuildContext context) {
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.
    return Scaffold(
      appBar: AppBar(
        // Here we take the value from the MyHomePage object that was created by
        // the App.build method, and use it to set our appbar title.
        title: Text(widget.title),
      ),
      body: Center(
        // Center is a layout widget. It takes a single child and positions it
        // in the middle of the parent.
        child: Column(
          // Column is also a layout widget. It takes a list of children and
          // arranges them vertically. By default, it sizes itself to fit its
          // children horizontally, and tries to be as tall as its parent.
          //
          // Invoke "debug painting" (press "p" in the console, choose the
          // "Toggle Debug Paint" action from the Flutter Inspector in Android
          // Studio, or the "Toggle Debug Paint" command in Visual Studio Code)
          // to see the wireframe for each widget.
          //
          // Column has various properties to control how it sizes itself and
          // how it positions its children. Here we use mainAxisAlignment to
          // center the children vertically; the main axis here is the vertical
          // axis because Columns are vertical (the cross axis would be
          // horizontal).
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text(
              "$content$change",
              style: TextStyle(
                color: Colors.red,
                fontSize: 14,
              ),
            ),
          ],
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: _doS2T,
        tooltip: 'Increment',
        child: Icon(Icons.play_arrow),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }
}
